VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} CountCharacters 
   Caption         =   "Zeichenzahl"
   ClientHeight    =   3240
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4665
   OleObjectBlob   =   "CountCharacters.frx":0000
   ShowModal       =   0   'False
End
Attribute VB_Name = "CountCharacters"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public TimeOnOff As Boolean
Dim oDoc As Document
Dim marke1, marke2 As String, vorZ As Integer, lu As Integer
Const t1 = "starten der Zhlung"
Const t2 = "stoppen der Zhlung"
Dim pos As Long, valProg As Integer

'Funktion zum Erzeugen eines akustischen Signals
Private Declare Function Beep Lib "kernel32" (ByVal Fq As Long, ByVal Tm As Long) As Long

Private Sub UserForm_Activate()
    If oDoc Is Nothing Then Set oDoc = ActiveDocument
End Sub

Private Sub UserForm_Initialize()
    Randomize
    marke1 = "": marke2 = ""  'Namen der Textmarken voreinstellen
    For i = 0 To 5
        marke1 = marke1 + Chr((121 - 97 + 1) * Rnd() + 97)  '6 Kleinbuchstaben
        marke2 = marke2 + Chr((121 - 97 + 1) * Rnd() + 97)
    Next
    mrk1.text = marke1: mrk2.text = marke2
    TextBox1.text = GetSetting("CountCharacters", "Daten", "anzGrenze")
    vorZ = CInt(TextBox1.text)  'Einstellung einer Grenze fr Zeichenzahl
    progress.Width = 0  'Progressbarbreite
    If vorZ > TextBox1.Width Then
        valProg = CInt(Runden(vorZ / TextBox1.Width, 0))
    Else
        valProg = CInt(Runden(TextBox1.Width / vorZ, 0))
    End If
    lblAnzahl.borderColor = &H80000006
    lblAnzahl.Caption = ""
    lblUebrig.Caption = ""
    
    With Me 'die UserForm an den rechten Rand des Wordfensters setzen
      .StartupPosition = 0
      .Top = Application.Top + (0.5 * Application.Height) - (0.5 * .Height)
      lu = Application.Left + Application.Width
      If lu + .Width > ScreenRect.Right - ScreenRect.Left Then  'Bildschirmrand berschritten
        .Left = lu - .Width
      Else
        .Left = lu
      End If
    End With
    CommandButton3.SetFocus
End Sub

Private Sub TextBox1_Change()
    TextBox1.text = Format(CInt(TextBox1.text), "#,##0")
    vorZ = CInt(TextBox1.text)  'Grenze fr Zeichenzahl
End Sub

Private Sub mrk1_Change()
    marke1 = mrk1.text  'eventuell genderten Textmarkennamen bernehmen
End Sub

Private Sub mrk2_Change()
    marke2 = mrk2.text  'eventuell genderten Textmarkennamen bernehmen
End Sub

Private Sub CommandButton2_Click()  'den Prozess der Zeichenzhlung stoppen, Userform beenden
    TextBox1.BackColor = Me.BackColor
    TimeOnOff = False
    Unload Me
End Sub

Private Sub CommandButton3_Click()  'starten der Zeichenzhlung
    'die Zeichenzhlung beginnt im Dokument an der Stelle, wo sich gerade der Textcursor befindet
    oDoc.Bookmarks.Add Name:=marke1, Range:=selection.Range 'erste Textmarke setzen
    progress.Width = 0  'Progressbarbreite
    If CommandButton3.Caption = t1 Then 'prfen, ob Button auf starten oder stoppen eingestellt ist
    ' starten
        lblAnzahl.Caption = ""
        lblAnzahl.borderColor = &HC000&
        lblUebrig.Caption = ""
        CommandButton3.Caption = t2
        TimeOnOff = True    'Timer starten
        Timer   'Timer-Aktion
    Else
    ' stoppen
        ' die beiden benutzten Textmarken lschen
        If oDoc.Bookmarks.Exists(marke1) Then oDoc.Bookmarks.Item(marke1).Delete
        If oDoc.Bookmarks.Exists(marke2) Then oDoc.Bookmarks.Item(marke2).Delete
        TextBox1.BackColor = Me.BackColor
        lblAnzahl.Caption = " 0"
        lblAnzahl.borderColor = &H80000006
        lblUebrig.Caption = "0"
        lblUebrig.ForeColor = &H80000012
        CommandButton3.Caption = t1
        TimeOnOff = False   'Timer stoppen
    End If
End Sub

Public Sub Timer()  'die Timer-Aktion (findet jede Sekunde statt)
    Dim s As Integer
    While TimeOnOff = True
        If Second(Now) > s Or Second(Now) = 0 Then
            If oDoc.Bookmarks.Exists(marke2) Then oDoc.Bookmarks.Item(marke2).Delete
            oDoc.Bookmarks.Add Name:=marke2 'zweite Textmarke setzen
            TextZwischenZweiTextmarkenMarkieren marke1, marke2  'markieren Text zwischen den Textmarken
            Textzaehlen 'ermitteln der Zhlungen zum markierten Text
            selection.Collapse  'Markierung weg
            selection.GoTo What:=wdGoToBookmark, Name:=marke2
            s = Second(Now)
        End If
        DoEvents
    Wend
End Sub

'Ermittlung von bestimmten Anzahlen zum markierten Text
Sub Textzaehlen()
    Dim Worte, Seiten, Zeichen_ohne_Leerzeichen, Zeichen, _
        Zeichen_Absatz, Absatz, zeilen, Anzahl As Integer
    With selection.Range    'der markierte Text
        Seiten = .ComputeStatistics(wdStatisticPages)
        zeilen = .ComputeStatistics(wdStatisticLines)
        Worte = .ComputeStatistics(wdStatisticWords)
        Absatz = .ComputeStatistics(wdStatisticParagraphs)
        
        Zeichen = .ComputeStatistics(wdStatisticCharactersWithSpaces)
        Zeichen_ohne_Leerzeichen = .ComputeStatistics(wdStatisticCharacters)
        Zeichen_Absatz = Zeichen + Absatz
    End With
    Select Case True    'Anzahl gem gewhlter Zhlart setzen
        Case OptionButton1: Anzahl = Zeichen
        Case OptionButton2: Anzahl = Zeichen_ohne_Leerzeichen
        Case OptionButton3: Anzahl = Zeichen_Absatz
    End Select

    lblAnzahl.Caption = Format(Anzahl, " #,##0")
    lblUebrig.Caption = Format(vorZ - Anzahl, "#,##0 ")
    
    If vorZ > TextBox1.Width Then
        If Anzahl > 0 And Anzahl Mod valProg = 0 Then
            progress.Width = Anzahl * valProg   'Progressbarbreite
        End If
    Else
        If Anzahl > 0 Then
            progress.Width = Anzahl * valProg   'Progressbarbreite
        End If
    End If
    
    If Anzahl > vorZ Then   'prfen, ob aktuelle Anzahl die vorgegebene bersteigt
        TextBox1.BackColor = &HFF
        lblUebrig.ForeColor = &HFF
'        Beep 392, 200   'Signal
    Else
        TextBox1.BackColor = Me.BackColor
    End If
    If progress.Width > TextBox1.Width Or Anzahl = vorZ Then progress.Width = TextBox1.Width
End Sub

Sub TextZwischenZweiTextmarkenMarkieren(ByVal m1 As String, ByVal m2 As String) 'Text markieren
    With oDoc
        If .Bookmarks.Exists(m1) And .Bookmarks.Exists(m2) Then
          .Range(Start:=.Bookmarks(m1).Range.Start, End:=.Bookmarks(m2).Range.Start).Select
        End If
    End With
End Sub

Private Sub UserForm_QueryClose(Cancel As Integer, CloseMode As Integer)
    SaveSetting "CountCharacters", "Daten", "anzGrenze", CInt(TextBox1.text)
    Unload Me
End Sub
